// C Header File
// Created 1/1/01; 10:49:39 PM

SCR_RECT SideWin = {{131,1,159,98}};

void ClearBoard();
void ClearPalette();
void CloseEditor();
void IncTunnelID(int dir);
void PlaceObject();
void SelectHor(int dir);
void SelectVer(int dir);
void ToggleLock();
void TurnLock(char state);
void WriteMarkerPlanes(int r, int c);  //Write palette selection marker to video planes
void WriteTunnelNumber(int r, int c, int id);

void CloseEditor()
{
 LockPlace=False; 
 WriteSpritePlanes(EditRow,EditCol,board[EditRow][EditCol]); 
// ClearPalette();
 InEditor=False;
 OSFreeTimer(USER_TIMER);
 OSRegisterTimer(USER_TIMER,1);
}

void ToggleLock()
{
	FontSetSys(F_6x8);
 LockPlace=1-LockPlace;
 if (LockPlace==1)
 {
 	WriteTextPlanes(140,5,"\x0E",A_REPLACE);
 	PlaceObject();
 }
 else
  WriteTextPlanes(140,5,"   ",A_REPLACE);
}

void TurnLock(char state)
{
	LockPlace=state;
}

void IncTunnelID(int dir)
{
	if (board[EditRow][EditCol]>=80 && board[EditRow][EditCol]<=99)
	{
		board[EditRow][EditCol]+=dir;
		if (board[EditRow][EditCol]>99) board[EditRow][EditCol]=99;
		if (board[EditRow][EditCol]<80) board[EditRow][EditCol]=80;
		WriteTunnelNumber(EditRow,EditCol,board[EditRow][EditCol]);
 }
}

void ClearBoard()
{
 int r,c;
 for (r=0;r<12;r++)
  for (c=0;c<16;c++)
  {
   board[r][c]=0;
   WriteSpritePlanes(r,c,board[r][c]);
  }
 TankRow=11;
 TankCol=7;
 board[TankRow][TankCol]=TankUp;
 WriteSpritePlanes(TankRow,TankCol,TankUp);
}

void ClearPalette()
{
 PortSet(virtualA,239,127);
 ScrRectFill(&SideWin,&FullScr,A_REVERSE);
 PortSet(virtualB,239,127);
 ScrRectFill(&SideWin,&FullScr,A_REVERSE);
 PortSet(virtualC,239,127);
 ScrRectFill(&SideWin,&FullScr,A_REVERSE);
 PortSet(virtualD,239,127);
 ScrRectFill(&SideWin,&FullScr,A_REVERSE);
 PortSet(GetPlane(LIGHT_PLANE),239,127);
 ScrRectFill(&SideWin,&FullScr,A_REVERSE);
}

void DisplayPalette()
{
 int r,c,i;
 ClearPalette();
 PaletteRow=1;
 PaletteCol=0;	
 Paint=EditorPalette[PaletteRow][PaletteCol];
 tx=6;
 ty=0;
 wid=9;
 i=1;
 for (r=2;r<=10;r++)
  for(c=14;c<=16;c++)
  {
   WriteSpritePlanes(r,c,EditorPalette[r-2][c-14]);
  }
 WriteMarkerPlanes(PaletteRow,PaletteCol);
 tx=2;
 ty=2;
 wid=8;
}

void SelectHor(int dir)
{
 WriteMarkerPlanes(PaletteRow,PaletteCol);
 PaletteCol+=dir;
 if (PaletteCol>2) PaletteCol=0;
 if (PaletteCol<0) PaletteCol=2; 
// if (PaletteRow==0) PaletteCol=0;
 WriteMarkerPlanes(PaletteRow,PaletteCol);
 Paint=EditorPalette[PaletteRow][PaletteCol];
 if (Paint==6) TurnLock(Off);
 if (LockPlace) board[EditRow][EditCol]=Paint;
} 

void SelectVer(int dir)
{
 WriteMarkerPlanes(PaletteRow,PaletteCol);
 PaletteRow+=dir;
 if (PaletteRow>8) PaletteRow=0;
 if (PaletteRow<0) PaletteRow=8;
// if (PaletteRow==0) PaletteCol=0;
 WriteMarkerPlanes(PaletteRow,PaletteCol);
 Paint=EditorPalette[PaletteRow][PaletteCol];
 if (Paint==6) TurnLock(Off);
 if (LockPlace) board[EditRow][EditCol]=Paint;
}

void EdCursHor(int dir)
{
 if (board[EditRow][EditCol]<80 || board[EditRow][EditCol]>99)
 {
  WriteSpritePlanes(EditRow,EditCol,Background);
  WriteSpritePlanes(EditRow,EditCol,BottomSprite(board[EditRow][EditCol]));
  WriteSpritePlanes(EditRow,EditCol,TopSprite(board[EditRow][EditCol]));
 }
 else
  WriteTunnelNumber(EditRow,EditCol,board[EditRow][EditCol]);
 EditCol+=dir;
 if (EditCol>15) EditCol=0;
 if (EditCol<0) EditCol=15; 
 WriteSpritePlanes(EditRow,EditCol,PaintBrush);
 if (LockPlace) PlaceObject();
}

void EdCursVer(int dir)
{
 if (board[EditRow][EditCol]<80 || board[EditRow][EditCol]>99)
 {
 	WriteSpritePlanes(EditRow,EditCol,Background);
  WriteSpritePlanes(EditRow,EditCol,BottomSprite(board[EditRow][EditCol]));
  WriteSpritePlanes(EditRow,EditCol,TopSprite(board[EditRow][EditCol]));
 }
 else
  WriteTunnelNumber(EditRow,EditCol,board[EditRow][EditCol]);
 EditRow+=dir;
 if (EditRow>11) EditRow=0;
 if (EditRow<0) EditRow=11;
 WriteSpritePlanes(EditRow,EditCol,PaintBrush);
 if (LockPlace) PlaceObject();
}

void WriteMarkerPlanes(int r, int c)
{
 Sprite16(131+c*9,17+r*9,10,Marker,GetPlane(DARK_PLANE),SPRT_XOR);
 Sprite16(131+c*9,17+r*9,10,Marker,GetPlane(LIGHT_PLANE),SPRT_XOR);
 Sprite16(131+c*9,17+r*9,10,Marker,virtualA,SPRT_XOR);
 Sprite16(131+c*9,17+r*9,10,Marker,virtualC,SPRT_XOR);
}

void WriteTunnelNumber(int r, int c, int id)
{
 char tnum[]={"     "}; //5 spaces
	WriteSpritePlanes(r,c,Background);
 FontSetSys(F_4x6);
 sprintf(tnum,"%02u",id-80);
 PortSet(virtualA,239,127); 
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
 PortSet(virtualB,239,127); 
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
 PortSet(virtualC,239,127); 
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
 PortSet(virtualD,239,127); 
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
 SetPlane(DARK_PLANE);
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
 SetPlane(LIGHT_PLANE);
 DrawStrXY(tx+c*wid,ty+2+r*wid,tnum,A_REPLACE);
}

void PlaceObject()
{
 board[EditRow][EditCol]=Paint;
 if (Paint==6 && (EditRow!=TankRow || EditCol!=TankCol))
 {
  board[TankRow][TankCol]=0;
  WriteSpritePlanes(TankRow,TankCol,0);
  TankRow=EditRow;
  TankCol=EditCol;
 }
}


void BlinkCursor()
{
 static int flipflop=1;
 switch(flipflop)
 {
  case 0:
   WriteSpritePlanes(EditRow,EditCol,PaintBrush);break;
  case 1:
   if (board[EditRow][EditCol]<80 || board[EditRow][EditCol]>99)
   {
    WriteSpritePlanes(EditRow,EditCol,Background);
    WriteSpritePlanes(EditRow,EditCol,BottomSprite(board[EditRow][EditCol]));
    WriteSpritePlanes(EditRow,EditCol,TopSprite(board[EditRow][EditCol]));
   }
   else
    WriteTunnelNumber(EditRow,EditCol,board[EditRow][EditCol]);
  break;  
 }
 flipflop=1-flipflop;	
}
